org.apache.commons.compress.archivers.tar

## Class TarArchiveOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - org.apache.commons.compress.archivers.ArchiveOutputStream
    - - org.apache.commons.compress.archivers.tar.TarArchiveOutputStream

- All Implemented Interfaces:
    Closeable, Flushable, AutoCloseable

      public class TarArchiveOutputStream
      extends ArchiveOutputStream

  The TarOutputStream writes a UNIX tar archive as an OutputStream. Methods are provided to put entries, and then write their contents by writing to this stream using write().

  tar archives consist of a sequence of records of 512 bytes each that are grouped into blocks. Prior to Apache Commons Compress 1.14 it has been possible to configure a record size different from 512 bytes and arbitrary block sizes. Starting with Compress 1.15 512 is the only valid option for the record size and the block size must be a multiple of 512. Also the default block size changed from 10240 bytes prior to Compress 1.15 to 512 bytes with Compress 1.15.

  This class is not thread-safe

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `BIGNUMBER_ERROR` Fail if a big number (e.g.
    `static int` | `BIGNUMBER_POSIX` POSIX/PAX extensions are used to store big numbers in the archive.
    `static int` | `BIGNUMBER_STAR` star/GNU tar/BSD tar extensions are used to store big number in the archive.
    `static int` | `LONGFILE_ERROR` Fail if a long file name is required in the archive.
    `static int` | `LONGFILE_GNU` GNU tar extensions are used to store long file names in the archive.
    `static int` | `LONGFILE_POSIX` POSIX/PAX extensions are used to store long file names in the archive.
    `static int` | `LONGFILE_TRUNCATE` Long paths will be truncated in the archive.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TarArchiveOutputStream(OutputStream os)` Constructor for TarArchiveOutputStream.
    `TarArchiveOutputStream(OutputStream os, int blockSize)` Constructor for TarArchiveOutputStream.
    `TarArchiveOutputStream(OutputStream os, int blockSize, int recordSize)` Deprecated. recordSize must always be 512 bytes. An IllegalArgumentException will be thrown if any other value is used
    `TarArchiveOutputStream(OutputStream os, int blockSize, int recordSize, String encoding)` Deprecated. recordSize must always be 512 bytes. An IllegalArgumentException will be thrown if any other value is used.
    `TarArchiveOutputStream(OutputStream os, int blockSize, String encoding)` Constructor for TarArchiveOutputStream.
    `TarArchiveOutputStream(OutputStream os, String encoding)` Constructor for TarArchiveOutputStream.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Closes the underlying OutputStream.
    `void` | `closeArchiveEntry()` Close an entry.
    `ArchiveEntry` | `createArchiveEntry(File inputFile, String entryName)` Create an archive entry using the inputFile and entryName provided.
    `ArchiveEntry` | `createArchiveEntry(Path inputPath, String entryName, LinkOption... options)` Create an archive entry using the inputPath and entryName provided.
    `void` | `finish()` Ends the TAR archive without closing the underlying OutputStream.
    `void` | `flush()`
    `long` | `getBytesWritten()` Returns the current number of bytes written to this stream.
    `int` | `getCount()` Deprecated.
    `int` | `getRecordSize()` Deprecated.
    `void` | `putArchiveEntry(ArchiveEntry archiveEntry)` Put an entry on the output stream.
    `void` | `setAddPaxHeadersForNonAsciiNames(boolean b)` Whether to add a PAX extension header for non-ASCII file names.
    `void` | `setBigNumberMode(int bigNumberMode)` Set the big number mode.
    `void` | `setLongFileMode(int longFileMode)` Set the long file mode.
    `void` | `write(byte[] wBuf, int wOffset, int numToWrite)` Writes bytes to the current tar archive entry.

    - ### Methods inherited from class org.apache.commons.compress.archivers.ArchiveOutputStream

      `canWriteEntryData, count, count, write`

    - ### Methods inherited from class java.io.OutputStream

      `write`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### LONGFILE_ERROR

          public static final int LONGFILE_ERROR

      Fail if a long file name is required in the archive.
      See Also:
        Constant Field Values

    - #### LONGFILE_TRUNCATE

          public static final int LONGFILE_TRUNCATE

      Long paths will be truncated in the archive.
      See Also:
        Constant Field Values

    - #### LONGFILE_GNU

          public static final int LONGFILE_GNU

      GNU tar extensions are used to store long file names in the archive.
      See Also:
        Constant Field Values

    - #### LONGFILE_POSIX

          public static final int LONGFILE_POSIX

      POSIX/PAX extensions are used to store long file names in the archive.
      See Also:
        Constant Field Values

    - #### BIGNUMBER_ERROR

          public static final int BIGNUMBER_ERROR

      Fail if a big number (e.g. size > 8GiB) is required in the archive.
      See Also:
        Constant Field Values

    - #### BIGNUMBER_STAR

          public static final int BIGNUMBER_STAR

      star/GNU tar/BSD tar extensions are used to store big number in the archive.
      See Also:
        Constant Field Values

    - #### BIGNUMBER_POSIX

          public static final int BIGNUMBER_POSIX

      POSIX/PAX extensions are used to store big numbers in the archive.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### TarArchiveOutputStream

          public TarArchiveOutputStream(OutputStream os)

      Constructor for TarArchiveOutputStream.

      Uses a block size of 512 bytes.

      Parameters:
        `os` - the output stream to use

    - #### TarArchiveOutputStream

          public TarArchiveOutputStream(OutputStream os,
                                        int blockSize)

      Constructor for TarArchiveOutputStream.
      Parameters:
        `os` - the output stream to use
        `blockSize` - the block size to use. Must be a multiple of 512 bytes.

    - #### TarArchiveOutputStream

          @Deprecated
          public TarArchiveOutputStream(OutputStream os,
                                                    int blockSize,
                                                    int recordSize)

      Deprecated. recordSize must always be 512 bytes. An IllegalArgumentException will be thrown if any other value is used
      Constructor for TarArchiveOutputStream.
      Parameters:
        `os` - the output stream to use
        `blockSize` - the block size to use
        `recordSize` - the record size to use. Must be 512 bytes.

    - #### TarArchiveOutputStream

          @Deprecated
          public TarArchiveOutputStream(OutputStream os,
                                                    int blockSize,
                                                    int recordSize,
                                                    String encoding)

      Deprecated. recordSize must always be 512 bytes. An IllegalArgumentException will be thrown if any other value is used.
      Constructor for TarArchiveOutputStream.
      Parameters:
        `os` - the output stream to use
        `blockSize` - the block size to use . Must be a multiple of 512 bytes.
        `recordSize` - the record size to use. Must be 512 bytes.
        `encoding` - name of the encoding to use for file names
      Since:
        1.4

    - #### TarArchiveOutputStream

          public TarArchiveOutputStream(OutputStream os,
                                        int blockSize,
                                        String encoding)

      Constructor for TarArchiveOutputStream.
      Parameters:
        `os` - the output stream to use
        `blockSize` - the block size to use. Must be a multiple of 512 bytes.
        `encoding` - name of the encoding to use for file names
      Since:
        1.4

    - #### TarArchiveOutputStream

          public TarArchiveOutputStream(OutputStream os,
                                        String encoding)

      Constructor for TarArchiveOutputStream.

      Uses a block size of 512 bytes.

      Parameters:
        `os` - the output stream to use
        `encoding` - name of the encoding to use for file names
      Since:
        1.4

  - ### Method Detail

    - #### close

          public void close()
                     throws IOException

      Closes the underlying OutputStream.
      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Overrides:
        `close` in class `OutputStream`
      Throws:
        `IOException` - on error

    - #### closeArchiveEntry

          public void closeArchiveEntry()
                                 throws IOException

      Close an entry. This method MUST be called for all file entries that contain data. The reason is that we must buffer data written to the stream in order to satisfy the buffer's record based writes. Thus, there may be data fragments still being assembled that must be written to the output stream before this entry is closed and the next entry written.
      Specified by:
        `closeArchiveEntry` in class `ArchiveOutputStream`
      Throws:
        `IOException` - on error

    - #### createArchiveEntry

          public ArchiveEntry createArchiveEntry(File inputFile,
                                                 String entryName)
                                          throws IOException

      Description copied from class: `ArchiveOutputStream`
      Create an archive entry using the inputFile and entryName provided.
      Specified by:
        `createArchiveEntry` in class `ArchiveOutputStream`
      Parameters:
        `inputFile` - the file to create the entry from
        `entryName` - name to use for the entry
      Returns:
        the ArchiveEntry set up with details from the file
      Throws:
        `IOException` - if an I/O error occurs

    - #### createArchiveEntry

          public ArchiveEntry createArchiveEntry(Path inputPath,
                                                 String entryName,
                                                 LinkOption... options)
                                          throws IOException

      Description copied from class: `ArchiveOutputStream`
      Create an archive entry using the inputPath and entryName provided. The default implementation calls simply delegates as:

          return createArchiveEntry(inputFile.toFile(), entryName);

      Subclasses should override this method.
      Overrides:
        `createArchiveEntry` in class `ArchiveOutputStream`
      Parameters:
        `inputPath` - the file to create the entry from
        `entryName` - name to use for the entry
        `options` - options indicating how symbolic links are handled.
      Returns:
        the ArchiveEntry set up with details from the file
      Throws:
        `IOException` - if an I/O error occurs

    - #### finish

          public void finish()
                      throws IOException

      Ends the TAR archive without closing the underlying OutputStream. An archive consists of a series of file entries terminated by an end-of-archive entry, which consists of two 512 blocks of zero bytes. POSIX.1 requires two EOF records, like some other implementations.
      Specified by:
        `finish` in class `ArchiveOutputStream`
      Throws:
        `IOException` - on error

    - #### flush

          public void flush()
                     throws IOException

      Specified by:
        `flush` in interface `Flushable`
      Overrides:
        `flush` in class `OutputStream`
      Throws:
        `IOException`

    - #### getBytesWritten

          public long getBytesWritten()

      Description copied from class: `ArchiveOutputStream`
      Returns the current number of bytes written to this stream.
      Overrides:
        `getBytesWritten` in class `ArchiveOutputStream`
      Returns:
        the number of written bytes

    - #### getCount

          @Deprecated
          public int getCount()

      Deprecated.
      Description copied from class: `ArchiveOutputStream`
      Returns the current number of bytes written to this stream.
      Overrides:
        `getCount` in class `ArchiveOutputStream`
      Returns:
        the number of written bytes

    - #### getRecordSize

          @Deprecated
          public int getRecordSize()

      Deprecated.
      Get the record size being used by this stream's TarBuffer.
      Returns:
        The TarBuffer record size.

    - #### putArchiveEntry

          public void putArchiveEntry(ArchiveEntry archiveEntry)
                               throws IOException

      Put an entry on the output stream. This writes the entry's header record and positions the output stream for writing the contents of the entry. Once this method is called, the stream is ready for calls to write() to write the entry's contents. Once the contents are written, closeArchiveEntry() MUST be called to ensure that all buffered data is completely written to the output stream.
      Specified by:
        `putArchiveEntry` in class `ArchiveOutputStream`
      Parameters:
        `archiveEntry` - The TarEntry to be written to the archive.
      Throws:
        `IOException` - on error
        `ClassCastException` - if archiveEntry is not an instance of TarArchiveEntry
        `IllegalArgumentException` - if the `longFileMode` equals `LONGFILE_ERROR` and the file name is too long
        `IllegalArgumentException` - if the `bigNumberMode` equals `BIGNUMBER_ERROR` and one of the numeric values exceeds the limits of a traditional tar header.

    - #### setAddPaxHeadersForNonAsciiNames

          public void setAddPaxHeadersForNonAsciiNames(boolean b)

      Whether to add a PAX extension header for non-ASCII file names.
      Parameters:
        `b` - whether to add a PAX extension header for non-ASCII file names.
      Since:
        1.4

    - #### setBigNumberMode

          public void setBigNumberMode(int bigNumberMode)

      Set the big number mode. This can be BIGNUMBER_ERROR(0), BIGNUMBER_STAR(1) or BIGNUMBER_POSIX(2). This specifies the treatment of big files (sizes > TarConstants.MAXSIZE) and other numeric values too big to fit into a traditional tar header. Default is BIGNUMBER_ERROR.
      Parameters:
        `bigNumberMode` - the mode to use
      Since:
        1.4

    - #### setLongFileMode

          public void setLongFileMode(int longFileMode)

      Set the long file mode. This can be LONGFILE_ERROR(0), LONGFILE_TRUNCATE(1), LONGFILE_GNU(2) or LONGFILE_POSIX(3). This specifies the treatment of long file names (names >= TarConstants.NAMELEN). Default is LONGFILE_ERROR.
      Parameters:
        `longFileMode` - the mode to use

    - #### write

          public void write(byte[] wBuf,
                            int wOffset,
                            int numToWrite)
                     throws IOException

      Writes bytes to the current tar archive entry. This method is aware of the current entry and will throw an exception if you attempt to write bytes past the length specified for the current entry.
      Overrides:
        `write` in class `OutputStream`
      Parameters:
        `wBuf` - The buffer to write to the archive.
        `wOffset` - The offset in the buffer from which to get bytes.
        `numToWrite` - The number of bytes to write.
      Throws:
        `IOException` - on error

Copyright © 2002–2022 The Apache Software Foundation. All rights reserved.